/*
  $Header: d:\\Personal\\cvs/aj/src/language/APIAspect.java,v 1.1 2002/04/19 04:35:03 ikk Exp $ $Name:  $

  $Log: APIAspect.java,v $
  Revision 1.1  2002/04/19 04:35:03  ikk
  Initial.

*/

import org.aspectj.lang.*;
import org.aspectj.lang.reflect.*;

public aspect APIAspect
{
    public static final String cvs="$Id: APIAspect.java,v 1.1 2002/04/19 04:35:03 ikk Exp $";

    pointcut p(): if(true);

    before() : p() && !within(APIAspect)
    {
        System.out.println("******* "+thisJoinPointStaticPart.toString()+" *******");
        System.out.println("Target:         "+thisJoinPoint.getThis());
        System.out.println("This:           "+thisJoinPoint.getTarget());

        Object o[] = thisJoinPoint.getArgs();
        System.out.print("Arguments:      ");
        for(int i=0; i<o.length; i++ )
        {
            System.out.print(o[i].getClass().getName()+"("+o[i]+") ");
        }
        System.out.println();

        Signature sig = thisJoinPointStaticPart.getSignature();
        System.out.println("Signature:      "+sig.toString());
        System.out.println("Signature name: "+sig.getName());
        System.out.println("Declaring type: "+sig.getDeclaringType());

        if( sig instanceof CatchClauseSignature )
        {
            System.out.println("Singature type:    "+"CatchClause");
            System.out.println("   Param type:  "+((CatchClauseSignature) sig).getParameterType());
            System.out.println("   Param name:  "+((CatchClauseSignature) sig).getParameterName());
        }
        if( sig instanceof MemberSignature )
        {
            System.out.println("Singature type:   "+"Member");
        }
        if( sig instanceof CodeSignature )
        {
            System.out.println("Singature type:   "+"Code");
            
            Class  c[] = ((CodeSignature) sig).getParameterTypes();
            String s[] = ((CodeSignature) sig).getParameterNames();
            for(int i = 0; i<c.length; i++)
            {
                System.out.println("   Param type:   "+c[i]);
                System.out.println("   Param name:   "+s[i]);
            }

            Class  e[] = ((CodeSignature) sig).getExceptionTypes();
            for(int i = 0; i<e.length; i++)
            {
                System.out.println("   Exception type: "+e[i]);
            }

        }
        if( sig instanceof AdviceSignature )
        {
            System.out.println("Singature type:   "+"Advice");
            System.out.println("   Return type: "+((AdviceSignature) sig).getReturnType());
        }
        if( sig instanceof ConstructorSignature )
        {
            System.out.println("Singature type:   "+"Constructor");
        }
        if( sig instanceof InitializerSignature )
        {
            System.out.println("Singature type:   "+"Initializer");
        }
        if( sig instanceof MethodSignature )
        {
            System.out.println("Singature type:   "+"Method");
            System.out.println("   Return type: "+((MethodSignature) sig).getReturnType());
        }
        if( sig instanceof FieldSignature )
        {
            System.out.println("Singature type:   "+"Field");
            System.out.println("    Field type:   "+((FieldSignature) sig).getFieldType());
        }

        SourceLocation sl =  thisJoinPointStaticPart.getSourceLocation();
        System.out.println("Within type:      "+sl.getWithinType());
        System.out.println("File name:        "+sl.getFileName());
        System.out.println("Line:             "+sl.getLine());
        System.out.println("Column:           "+sl.getColumn());

    }
}
