/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/Pooling.java,v 1.2 2002/02/07 05:57:49 ikk Exp $ $Name:  $

  $Log: Pooling.java,v $
  Revision 1.2  2002/02/07 05:57:49  ikk
  Removed stack size limitation.

  Revision 1.1  2002/02/06 03:14:26  ikk
  Initial.

*/

package aspects;

import java.sql.*;
import java.util.*;

public aspect Pooling
{
    public static final String cvs="$Id: Pooling.java,v 1.2 2002/02/07 05:57:49 ikk Exp $";

    private static Stack pool = new Stack();

    pointcut poolGet(): call(static Connection DriverManager.getConnection(..));
    pointcut poolPut(): call(void Connection.close());
    
    Connection around() throws SQLException: poolGet()
    {
        synchronized(pool)
        {
            if(pool.empty())
            {
                return proceed();
            }
            return (Connection)pool.pop();
        }
    }

    void around(): poolPut()
    {
        Connection conn = (Connection)thisJoinPoint.getTarget();
        pool.push(conn);
    }
}


