/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/Tracer.java,v 1.1 2002/01/23 05:42:26 ikk Exp $ $Name:  $

  $Log: Tracer.java,v $
  Revision 1.1  2002/01/23 05:42:26  ikk
  Initial.


*/

package aspects;

import java.util.*;
import servlets.*;

public aspect Tracer
{
    public static final String cvs="$Id: Tracer.java,v 1.1 2002/01/23 05:42:26 ikk Exp $";

//    pointcut tracePoint(): execution(* *.*(..)) && !within(Tracer) && !within(Synchronizing) && !within(Init);
    pointcut tracePoint(): execution(* *.*(..)) && !within(Tracer) && !within(Init);

    private static Map stackDepths = new HashMap();

    before() : tracePoint()
    {
        Integer depth = (Integer)stackDepths.get(Thread.currentThread());
        if( null == depth )
        {
            depth = new Integer(0);
        }
        Init.log(ident(depth.intValue()) + " >> "  + thisJoinPointStaticPart.getSignature());
        stackDepths.put(Thread.currentThread(), new Integer(depth.intValue()+1));
    }

    after() : tracePoint()
    {
        Integer depth = (Integer)stackDepths.get(Thread.currentThread());
        depth = new Integer(depth.intValue()-1);
        if( 0 == depth.intValue() )
        {
            stackDepths.remove(Thread.currentThread());
        }
        else
        {
            stackDepths.put(Thread.currentThread(), depth);
        }
        Init.log(ident(depth.intValue()) + " << " + thisJoinPointStaticPart.getSignature());
    }

    private static StringBuffer ident(int num)
    {
        StringBuffer ident = new StringBuffer();
        for(int i=0; i<num; i++)
        {
            ident.append(' ');
        }
        ident.append(Integer.toString(num)+" ["+Thread.currentThread().hashCode()+"]");

        return ident;
    }
}
