/*
  $Header: d:\\Personal\\cvs/aj/src/servlets/Init.java,v 1.4 2002/01/21 00:47:14 ikk Exp $ $Name:  $

  $Log: Init.java,v $
  Revision 1.4  2002/01/21 00:47:14  ikk
  Removed storage map.

  Revision 1.3  2002/01/21 00:45:50  ikk
  Added exception handling on JDBC driver loading.

  Revision 1.2  2002/01/21 00:15:59  ikk
  Changed to use store servlet context. Added JDBC driver loading.

  Revision 1.1  2002/01/20 19:35:41  ikk
  Initial.

*/

package servlets;

import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class Init extends HttpServlet
{
    public static final String cvs="$Id: Init.java,v 1.4 2002/01/21 00:47:14 ikk Exp $";

    private static ServletContext sc = null;

    public static String getParameter(String key)
    {
        return sc.getInitParameter(key);
    }

    public static void log(String message)
    {
        sc.log(message);
    }

    public static void log(String message, Throwable throwable)
    {
        sc.log(message, throwable);
    }

    public void init() throws ServletException
    {
        sc = getServletContext();

        String name, value;
        for (Enumeration e = sc.getInitParameterNames() ; e.hasMoreElements() ;)
        {
            name = (String)e.nextElement();
            value = getParameter(name);

            Init.log(name + " -> " +value);
        }

        try
        {
            Class.forName(getParameter("dbdriver")).newInstance(); 
        }
        catch(Exception e)
        {
            throw new ServletException("Cannot load JDBC driver :"+getParameter("dbdriver"), e);
        }
    }
}

