/*
  $Header: d:\\Personal\\cvs/aj/src/tags/StoriesTag.java,v 1.7 2002/02/08 14:36:33 ikk Exp $ $Name:  $

  $Log: StoriesTag.java,v $
  Revision 1.7  2002/02/08 14:36:33  ikk
  Added Id.

  Revision 1.6  2002/01/29 04:25:42  ikk
  Removed package qualifier for body.

  Revision 1.5  2002/01/29 02:30:55  ikk
  Removed exception handling.

  Revision 1.4  2002/01/12 02:53:45  ikk
  Uncommented native tag lib import.

  Revision 1.3  2002/01/08 23:32:31  ikk
  Removed some debug output.

  Revision 1.2  2002/01/08 03:56:57  ikk
  Implemented db retrieval of the stories.

  Revision 1.1  2002/01/04 02:35:32  ikk
  Initial.

*/

package tags;

import java.util.*;
import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import db.*;

public class StoriesTag extends BodyTagSupport
{
    public static final String cvs="$Id: StoriesTag.java,v 1.7 2002/02/08 14:36:33 ikk Exp $";

    private String name;
    private Iterator iterator;

    public void setName(String name)
    {
        this.name = name;
    }

    public int doStartTag() throws JspException
    {
        String user = (String)pageContext.getSession().getAttribute("user");
        iterator = StoriesDb.retrieve(user).iterator();

        if(iterator.hasNext())
        {
            Story story = (Story)iterator.next();
            pageContext.setAttribute(name, story.category+" -- "+story.body);
            return EVAL_BODY_TAG;
        }
        else
        {
            return SKIP_BODY;
        }
    }

    public int doAfterBody() throws JspException
    {
        BodyContent body = getBodyContent();

        body.writeOut(getPreviousOut());

        body.clearBody();
        if (iterator.hasNext())
        {
            Story story = (Story)iterator.next();
            pageContext.setAttribute(name, story.category+" -- "+story.body);
            return EVAL_BODY_TAG;
        }
        else
        {
            return SKIP_BODY;
        }
    }
}
